#include "char.h"
#include "item.h"
#include <stdio.h>

int printRace(int r) {
char *race_str[]={
    "Human   ", "Elf     ", "Dwarf   ", "Hobbit  ",
    "Half-Elf", "Half-Orc", "Gnome   " };
if (r<7) {
    printf("%s",race_str[r]);
    return 1;
} else {
    printf("Unknown ");
    return 0;
}
} /* printRace */

int printClass(int c) {
char *class_str[]={
    "Warrior ", "Paladin ", "Rogue   ", "Bard    ", "Hunter  ", 
    "Monk    ", "Conjurer", "Magician", "Sorceror", "Wizard  " };
if (c<10) {
    printf("%s",class_str[c]);
    return 1;
} else {
    printf("Class?? ");
    return 0;
}
} /* printClass */

int isBard(int c) {
	return (c==Bard);
}
int isMage(int c) {
	return (c>=Conjurer);
}
int printStatus(int s) {
    int set=0;

    if (s&0x02) { printf("Dead "     ); set=1; }
    if (s&0x04) { printf("Old "      ); set=1; }
    if (s&0x08) { printf("Poisoned " ); set=1; }
    if (s&0x10) { printf("Stoned "   ); set=1; }
    if (s&0x20) { printf("Paralyzed "); set=1; }
    if (s&0x40) { printf("Possessed "); set=1; }
    if (s&0x80) { printf("Nuts "     ); set=1; }
    if (s == 0) { printf("Alive "    ); set=1; }
    if (set==0) 
        printf("%d?! ",   s);

    return 1;
} /* printStatus */

int fgetBardCharacter(struct BARDCHAR *bard, FILE *fp) {
    fread(bard, sizeof(struct BARDCHAR), 1, fp);
    return 1;
}
int fputBardCharacter(struct BARDCHAR *bard, FILE *fp) {
    fwrite(bard, sizeof(struct BARDCHAR), 1, fp);
    return 1;
}

int dumpcharacter(struct BARDCHAR *bard) {
    int i;

    printf("\nRace/Class/Level: ");
    printRace(bard->race);
    printf("/");
    printClass(bard->class);
    printf("/%d", bard->level);
    printf("\nStatus: ");
    printStatus(bard->status);
    printf("\nXP    : %8lu    Gold   : %8lu", bard->experience, 
        bard->gold);
    printf("\nStrength    : %3d : %3d", bard->strength, bard->mstrength); 
    printf("\nIntelligence: %3d : %3d", bard->iq, bard->miq);
    printf("\nDexterity   : %3d : %3d", bard->dexterity, 
        bard->mdexterity);
    printf("\nConstitution: %3d : %3d", bard->constitution,
        bard->mconstitution);
    printf("\nLuck        : %3d : %3d", bard->luck, bard->mluck);
    printf("\nHealth      : %3d : %3d", bard->condition, bard->hp);
if (bard->class>5) { /* stats useful for magic users only */
    printf("\nSpell Points: %3d : %3d", bard->sppt, bard->msppt);
    printf("\nConjurer: %d         Magician: %d", bard->conjlevel, 
        bard->magilevel);
    printf("\nSorceror: %d         Wizard  : %d", bard->sorclevel, 
        bard->wizdlevel);
}
if (bard->class==3) { /* stat useful only for bard */
    printf("\nSongs remaining: %d", bard->songs);
}
    for (i=0; i<8; i++) {
if (bard->item[i].code) {
        printf("\n");
        printItemStatus(bard->item[i].status);
        printItemDesc(bard->item[i].code);
}
    }
    printf("\n");

    return 1;
}

int shortDumpChar(struct BARDCHAR *bard) {
    int i;

    printRace(bard->race);
    printf(" ");
    printClass(bard->class);
    printf(" Level %2d ", bard->level);
    printf("XP %8Ld AU %8Ld ", bard->experience, bard->gold);
    printf("\n             ");
    printf("ST%3d ", bard->mstrength); 
    printf("IQ%3d ", bard->miq);
    printf("DX%3d ", bard->mdexterity);
    printf("CN%3d ", bard->mconstitution);
    printf("LK%3d ", bard->mluck);
    printf("HP%3d ", bard->hp);
    printf("SP%3d ", bard->msppt);
    printf("%d%d%d%d ", bard->conjlevel, bard->magilevel, bard->sorclevel, 
        bard->wizdlevel);
    printf("%d ", bard->songs);
    printStatus(bard->status);
    printf("\n");

    return 1;
}
int csvDumpChar(struct BARDCHAR *bard) {
    int i;

    printRace(bard->race);
    printf(",");
    printClass(bard->class);
    printf(",%d,", bard->level);
    printf("%Ld,%Ld", bard->experience, bard->gold);
    printf(",");
    printf("%d,", bard->mstrength); 
    printf("%d,", bard->miq);
    printf("%d,", bard->mdexterity);
    printf("%d,", bard->mconstitution);
    printf("%d,", bard->mluck);
    printf("%d,", bard->hp);
    printf("%d,", bard->msppt);
    printf("%d,%d,%d,%d,", bard->conjlevel, bard->magilevel, bard->sorclevel, 
        bard->wizdlevel);
    printf("%d,", bard->songs);
    printStatus(bard->status);
    printf("\n");

    return 1;
}
int csvDumpHeader(void) {
	printf("File,Char,Race,Class,Level,Experience,Gold,");
	printf("Strength,IQ,Dexterity,Constitution,Luck,");
	printf("Hit Points,Spell Points,");
	printf("Conjurer,Magician,Sorceror,Wizard,Songs,Status");
	printf("\n");

    return 1;
}
